Index: outvar.f
===================================================================
--- outvar.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ outvar.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -4,15 +4,15 @@
 !
 ! Copyright 2005       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
+!                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
 !
 ! **************************************************************
-
+ 
       subroutine outvar(nml,fileName)
-
+  
 !--------------------------------------------------------------------
-!       Output of variables of the current protein conformation
-!-
+!       Output of variables of the current protein conformation 
+!- 
 !       nml != 0       :     molecule index
 !       nml  = 0       :     all molecules
@@ -25,10 +25,8 @@
       include 'INCL.H'
 
-      integer nml, ibegst, iout
-
       character*(*) fileName
 
       if (nml.lt.0.or.nml.gt.ntlml) then
-        write (logString, *) ' outvar>  No such molecule #',nml,' !'
+        write(*,*) ' outvar>  No such molecule #',nml,' !'
         return
       endif
@@ -52,10 +50,8 @@
       include 'INCL.H'
 
-      integer nml, im1, im2, iml, i, iout, ibegst, ifivr, is, nursvr, it
-
       character mlfd*7,strg(6)*17
 
       if (nml.lt.0.or.nml.gt.ntlml) then
-        write (logString, *) ' outvbs>  No such molecule #',nml,' !'
+        write(*,*) ' outvbs>  No such molecule #',nml,' !'
         return
       elseif (nml.gt.0) then
@@ -74,9 +70,9 @@
 
         if ( gbpr(1,iml).ne.zero
-     &   .or.gbpr(2,iml).ne.zero
-     &   .or.gbpr(3,iml).ne.zero
-     &   .or.gbpr(4,iml).ne.zero
-     &   .or.gbpr(5,iml).ne.zero
-     &   .or.gbpr(6,iml).ne.zero ) then
+     #   .or.gbpr(2,iml).ne.zero
+     #   .or.gbpr(3,iml).ne.zero
+     #   .or.gbpr(4,iml).ne.zero
+     #   .or.gbpr(5,iml).ne.zero
+     #   .or.gbpr(6,iml).ne.zero ) then
 
           do i = 1,3
@@ -88,6 +84,6 @@
 
           write(iout,'(1x,2a,1x,12a)')
-     &    '@ ',mlfd,(strg(i)(ibegst(strg(i)):),',',i=1,5),
-     &    strg(6)(ibegst(strg(6)):)
+     #    '@ ',mlfd,(strg(i)(ibegst(strg(i)):),',',i=1,5),
+     #    strg(6)(ibegst(strg(6)):)
 
         endif
@@ -101,5 +97,5 @@
 
             write(iout,'(3x,a,i3,1x,a,1x,a,1x,a,1x,f10.3)')
-     &        mlfd,(nursvr(i)-is),':',nmvr(i),':',vlvr(i)*crd
+     #        mlfd,(nursvr(i)-is),':',nmvr(i),':',vlvr(i)*crd
           else
 
@@ -109,6 +105,6 @@
 
               write(iout,'(3x,a,i3,1x,a,1x,a,1x,a,1x,f10.3,1x,a)')
-     &          mlfd,(nursvr(i)-is),':',nmvr(i),':',vlvr(i)*crd
-     &          ,' &'
+     #          mlfd,(nursvr(i)-is),':',nmvr(i),':',vlvr(i)*crd
+     #          ,' &'
             endif
 
Index: partem_p.f
===================================================================
--- partem_p.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ partem_p.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -1,28 +1,28 @@
-!**************************************************************
-!     
-! This file contains the subroutines: partem_p 
-! USE WITH main_p, NOT WITH main!!!!!!
-!     
-! Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku 
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
-!     
-!     **************************************************************
-
-!>
-!!     PURPOSE: SIMULATION OF PROTEINS BY PARALLEL TEMPERING ALGORITHM
-!!     ON PARALLEL COMPUTERS USING MPI
-!!
-!!     switch: Choses the starting configuration:
-!!     -1 - stretched configuration
-!!     0 - don't change anything
-!!     1 - random start configuration
-!!
-!!     CALLS:  addang,contacts,energy,hbond,helix,iendst,metropolis,
-!!     outvar,(rand),rgyr
-!<
+c**************************************************************
+c     
+c This file contains the subroutines: partem_p 
+C USE WITH main_p, NOT WITH main!!!!!!
+c     
+c Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
+c                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
+c     
+c     **************************************************************
+
       subroutine  partem_p(num_rep, nequi, nswp, nmes, nsave, newsta,
      &                     switch, rep_id, partem_comm)
+C     
+C     PURPOSE: SIMULATION OF PROTEINS BY PARALLEL TEMPERING ALGORITHM 
+C     ON PARALLEL COMPUTERS USING MPI
+C     
+C     switch: Choses the starting configuration:
+C     -1 - stretched configuration
+C     0 - don't change anything
+C     1 - random start configuration
+C     
+c     CALLS:  addang,contacts,energy,hbond,helix,iendst,metropolis,
+c     outvar,(rand),rgyr
+C     
       include 'INCL.H'
       include 'INCP.H'
@@ -31,50 +31,41 @@
       logical newsta
       integer switch, partem_comm, rep_id, nsave
-!     external rand
+c     external rand
       external can_weight
 
-!     nequi:  number of Monte Carlo sweeps for thermalization
-!     nswp:   number of Monte Carlo sweeps
-!     nmes:   number of Monte Carlo sweeps between measurments
-!     newsta: .true. for new simulations, .false. for re-start
-      double precision temp, eavm, sph, geavm, gsph, dv, grnd, vr
-      double precision addang, dummy, eol, energy, acz, rmsv, rmsdfun
-      double precision rgy, ee, tmhb, dham, swp, wij, rd, e_final
-
-      integer ifrrm, nmes, nswp, num_rep, i, j, nresi, iold, inode
-      integer intem, iv, jold, idum1, idum2, idum3
-      integer ierr, nsw, nequi
-      integer nml, nhel, mhel, nbet, mbet, mhb, imhb, nctot, ncnat
-      integer k1, k, nu, no1, in, jn
-      
+C     nequi:  number of Monte Carlo sweeps for thermalization
+C     nswp:   number of Monte Carlo sweeps
+C     nmes:   number of Monte Carlo sweeps between measurments
+C     newsta: .true. for new simulations, .false. for re-start
+
       dimension  eavm(MAX_PROC),sph(MAX_PROC),intem(MAX_PROC),
      &     inode(MAX_PROC), geavm(MAX_PROC), gsph(MAX_PROC)
       double precision    pbe(MAX_PROC),yol(MAX_PROC),acy(MAX_PROC),
      &     acy1(MAX_PROC),acx1(MAX_PROC),
-     &     rgyrp(MAX_PROC),rmsdp(MAX_PROC), eol0,acz0
+     &     rgyrp(MAX_PROC),rmsdp(MAX_PROC), eol0,rgyp,acz0
       
       double precision    e_min, e_minp(MAX_PROC), e_minpt(MAX_PROC)
       integer   h_max, h_maxp(MAX_PROC)
-!     Order of replica exchange
+c     Order of replica exchange
       integer   odd
 !     Counter to keep random number generators in sync
       integer randomCount
       
-!     Collect partial energies. Only the root writes to disk. We have to
-!     collect the information from the different replicas and provide 
-!     arrays to store them.
-!     eyslr    storage array for solvent energy
-!     eyelp     -      "        - coulomb energy
-!     eyvwp     -      "        - van-der-Waals energy
-!     eyhbp     -      "        - hydrogen bonding energy
-!     eysmi    -      "        - intermolecular interaction energy
-!     eyabp     -      "        - Abagyan correction term
+c     Collect partial energies. Only the root writes to disk. We have to
+c     collect the information from the different replicas and provide 
+c     arrays to store them.
+c     eyslr    storage array for solvent energy
+c     eyelp     -      "        - coulomb energy
+c     eyvwp     -      "        - van-der-Waals energy
+c     eyhbp     -      "        - hydrogen bonding energy
+c     eysmi    -      "        - intermolecular interaction energy
+c     eyabp     -      "        - Abagyan correction term
       double precision eyslr(MAX_PROC)
       double precision eyelp(MAX_PROC),eyvwp(MAX_PROC),eyhbp(MAX_PROC), 
      &     eyvrp(MAX_PROC),eysmip(MAX_PROC), eyabp(MAX_PROC)
-!     Collect information about accessible surface and van-der-Waals volume
-!     asap      storage array for solvent accessible surface
-!     vdvolp     storage array for van-der-Waals volume
-      double precision asa_p(MAX_PROC), vdvolp(MAX_PROC)
+c     Collect information about accessible surface and van-der-Waals volume
+c     asap      storage array for solvent accessible surface
+c     vdvolp     storage array for van-der-Waals volume
+      double precision asap(MAX_PROC), vdvolp(MAX_PROC)
 
       integer nhelp(MAX_PROC),nbetp(MAX_PROC), mhbp(MAX_PROC),
@@ -82,11 +73,11 @@
       integer imhbp(MAX_PROC)
       character*80 filebase, fileNameMP, tbase0,tbase1
-!     frame     frame number for writing configurations
-!     trackID   configuration that should be tracked and written out
-!     dir          direction in random walk
-!     -1 - visited highest temperature last
-!     1 - visited lowest temperature last
-!     0 - haven't visited the boundaries yet.
-!     dirp      storage array for directions.
+c     frame     frame number for writing configurations
+c     trackID   configuration that should be tracked and written out
+c     dir          direction in random walk
+c     -1 - visited highest temperature last
+c     1 - visited lowest temperature last
+c     0 - haven't visited the boundaries yet.
+c     dirp      storage array for directions.
       integer frame, trackID, dir
       integer dirp(MAX_PROC)
@@ -95,23 +86,23 @@
       trackID = 1
       odd = 1
-      write (logString, *) 'Starting parallel tempering.'
-      write (logString, *) 'parameters, ',switch,newsta,nmes,nswp,nmes,
+      write (*,*) 'Starting parallel tempering.'
+      write (*,*) 'parameters, ',switch,newsta,nmes,nswp,nmes,
      &            rep_id, num_rep, partem_comm, myrank
       call flush(6)
-!     
-!     
-!     File with temperatures 
+C     
+c     
+C     File with temperatures 
       open(11,file='temperatures',status='old')
-!     File with reference conformation
+C     File with reference conformation
       tbase0='trj_00000'
       open(18,file=fileNameMP(tbase0,5,9,rep_id),status='unknown')
       if (rep_id.eq.0.and.myrank.eq.0) then
-!     File with time series of simulation
+c     File with time series of simulation
          open(14,file='ts.d',status='unknown')
-!     Track weights
-!      open(16, file='weights.dat', status='unknown')
+c     Track weights
+c      open(16, file='weights.dat', status='unknown')
       endif
       
-!     READ IN TEMPERATURES
+C     READ IN TEMPERATURES
       do i=1,num_rep
          read(11,*) j,temp
@@ -120,8 +111,8 @@
       close(11)
 
-!     nresi:  number of residues
+c     nresi:  number of residues
       nresi=irsml2(1)-irsml1(1)+1
-!     
-!     Initialize variables
+C     
+C     Initialize variables
       do i=1,num_rep      
          acx1(i) = 0.0d0
@@ -141,5 +132,5 @@
       dir = dirp(rep_id + 1)
 
-!     _________________________________ Initialize Variables
+c     _________________________________ Initialize Variables
       if(newsta) then
          iold=0
@@ -148,5 +139,5 @@
             intem(i) = i
          end do
-!     _________________________________ initialize starting configuration
+c     _________________________________ initialize starting configuration
          if (switch.ne.0) then
             do i=1,nvr
@@ -167,5 +158,5 @@
             do i=1,num_rep
                read(13,*) j,inode(i),intem(i),yol(i),e_minp(i),h_maxp(i)
-               write (logString, *) "par_R.in:",i,j
+               write (*,*) "par_R.in:",i,j
             end do
             jold=(iold/nmes)*num_rep
@@ -178,5 +169,5 @@
      &              ,idum1, idum2, idum3, e_min
      &              ,dummy, dummy
-               write (logString, *) i
+               write (*,*) i
                call flush(6)
             end do
@@ -187,44 +178,43 @@
          CALL MPI_BCAST(INODE,num_rep,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
          CALL MPI_BCAST(YOL,num_rep,MPI_DOUBLE_PRECISION,0,
-     &        MPI_COMM_WORLD,IERR)
+     #        MPI_COMM_WORLD,IERR)
          CALL MPI_BCAST(E_MINP, num_rep, MPI_DOUBLE_PRECISION, 0, 
-     &        MPI_COMM_WORLD, IERR)
+     #        MPI_COMM_WORLD, IERR)
          CALL MPI_BCAST(h_maxp,num_rep,MPI_INTEGER,0,MPI_COMM_WORLD,
-     &        IERR)
+     $        IERR)
       end if
       
       BETA = pbe(inode(rep_id+1))
-      e_min = e_minp(rep_id+1)
-      h_max = h_maxp(rep_id+1)
-      write (logString, *) "E_min=",e_min," for ", rep_id + 1 
+      e_min = e_minp(inode(rep_id+1))
+      h_max = h_maxp(inode(rep_id+1))
+      write (*,*) "E_min=",e_min," for ", intem(rep_id + 1) 
       eol=energy()
       if(.not.newsta.and.abs(yol(rep_id + 1) - eol).gt.0.1) then
-         write (logString, *) rep_id, ' Warning: yol(rep_id).ne.eol:'
-         write (logString, *) rep_id, yol(rep_id + 1), eol
+         write(*,*) rep_id, ' Warning: yol(rep_id).ne.eol:'
+         write(*,*) rep_id, yol(rep_id + 1), eol
       endif
-!     Start of simulation
-      write (logString, *) '[',rep_id, myrank, beta, partem_comm,
+C     Start of simulation
+      write (*,*) '[',rep_id, myrank, beta, partem_comm,
      &            '] Energy before equilibration:', eol
-!     =====================Equilibration by canonical Metropolis
+c     =====================Equilibration by canonical Metropolis
       do nsw=1,nequi
          call metropolis(eol,acz,can_weight)
       end do
       CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
-      write (logString, *) '[',rep_id,'] Energy after equilibration:', 
-     &   eol
+      write (*,*) '[',rep_id,'] Energy after equilibration:', eol
       call flush(6)
-!     
-!======================Multiple Markov Chains
+C     
+C======================Multiple Markov Chains
       acz = 0
       do nsw=1,nswp
-!------------First ordinary Metropolis 
+c------------First ordinary Metropolis 
          call metropolis(eol,acz,can_weight)
          iold = iold + 1	
          eol0 = eol
          if (myrank.eq.0.and.rep_id.eq.0) then
-            write (logString, *) "Finished sweep", nsw
+            write (*,*) "Finished sweep", nsw
             call flush(6)
          endif
-         if(mod(iold,nmes).eq.0.and.myrank.eq.0) then
+         if(mod(iold,nmes).eq.0) then
             if ((rep_id + 1).eq.trackID.and.myrank.eq.0) then
                frame = iold /nmes
@@ -233,15 +223,15 @@
             endif
             acz0 = acz
-!     Evaluate RMSD
+c     Evaluate RMSD
             nml = 1
             rmsv = rmsdfun(nml,irsml1(nml),irsml2(nml),ixatp,xatp,yatp, &
      &             zatp,0)
-!            print *,myrank,'received RMSD,energy ',rmsv,eyab,beta
-!     Measure global radius of gyration
+c            print *,myrank,'received RMSD,energy ',rmsv,eyab,beta
+C     Measure global radius of gyration
             call rgyr(0,rgy,ee)  
             rgyp = rgy
-!     Measure Helicity and Sheetness
+C     Measure Helicity and Sheetness
             call helix(nhel,mhel,nbet,mbet)
-!     Measure Number of hydrogen bonds
+C     Measure Number of hydrogen bonds
             mhb = 0
             do i = 1, ntlml
@@ -250,41 +240,41 @@
             enddo
             call interhbond(imhb) 
-!     Measure total number of contacts (NCTOT) and number of
-!     native contacts (NCNAT)
+C     Measure total number of contacts (NCTOT) and number of
+C     native contacts (NCNAT)
             call contacts(nctot,ncnat,dham)
-!     Add tracking of lowest energy configuration
+c     Add tracking of lowest energy configuration
             if (eol.lt.e_min) then
-!     Write out configuration
+c     Write out configuration
                i=rep_id+1
                j=inode(i)
                e_min = eol
                filebase = "c_emin_0000.pdb"
-               call outpdb(0, fileNameMP(filebase, 8, 11, i))
+               call outpdb(0, fileNameMP(filebase, 8, 11, j))
                filebase = "c_emin_0000.var"
-               call outvar(0, fileNameMP(filebase, 8, 11, i))
+               call outvar(0, fileNameMP(filebase, 8, 11, j))
                filebase = "c_emin_0000.dat"
-               open(15, file=fileNameMP(filebase, 8, 11, i),
+               open(15, file=fileNameMP(filebase, 8, 11, j),
      &              status="unknown")
 !     write(15,'(i8,2i4,f6.2,2f8.2,5i8)') iold,i,j,pbe(i), 
-               write(15,*) iold,j,i,beta, 
+               write(15,*) iold,i,j,pbe(i), 
      &              eol, eyab, eysl, eyel, eyvw, eyhb, eyvr, eysmi,asa,
      &              vdvol, rgy, nhel, nbet, mhb, imhb, nctot,ncnat
                close(15)
             endif
-!     Add tracking of configuration with larges hydrogen contents.
+c     Add tracking of configuration with larges hydrogen contents.
             if ((mhb + imhb).gt.h_max) then
-!     Write out configuration
+c     Write out configuration
                i = rep_id + 1
                j = inode(i)
                h_max = mhb + imhb
                filebase = "c_hmax_0000.pdb"
-               call outpdb(0,fileNameMP(filebase,8,11,i))
+               call outpdb(0,fileNameMP(filebase,8,11,j))
                filebase = "c_hmax_0000.var"
-               call outvar(0,fileNameMP(filebase,8,11,i))
+               call outvar(0,fileNameMP(filebase,8,11,j))
                filebase = "c_hmax_0000.dat"
-               open(15, file=fileNameMP(filebase, 8, 11, i),
+               open(15, file=fileNameMP(filebase, 8, 11, j),
      &              status="unknown")
 !     write(15,'(i8,2i4,f6.2,2f8.2,5i8)') iold,i,j,pbe(i), 
-               write(15,*) iold,j,i,beta, 
+               write(15,*) iold,i,j,pbe(i), 
      &              eol, eyab, eysl, eyel, eyvw, eyhb, eyvr, eysmi,asa,
      &              vdvol, rgy, nhel, nbet, mhb, imhb, nctot,ncnat
@@ -292,15 +282,15 @@
             endif
 
-!     
-!--------------------Gather measurement data
+C     
+C--------------------Gather measurement data
 ! I only use the master node of each replica for data collection. The
 ! variable partem_comm provides the appropriate communicator.
             if (partem_comm.ne.MPI_COMM_NULL) then
                CALL MPI_GATHER(rmsv,1,MPI_DOUBLE_PRECISION,rmsdp,1,
-     &              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
+     #              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
                CALL MPI_GATHER(eyab,1,MPI_DOUBLE_PRECISION,eyabp,1,
-     &              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
+     #              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
                CALL MPI_GATHER(RGYP,1,MPI_DOUBLE_PRECISION,RGYRP,1,
-     &              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
+     #              MPI_DOUBLE_PRECISION, 0,partem_comm,IERR)
                CALL MPI_GATHER(NHEL,1,MPI_INTEGER,NHELP,1,MPI_INTEGER,
      &              0,partem_comm,IERR)
@@ -335,5 +325,5 @@
                CALL MPI_GATHER(eysmi,1,MPI_DOUBLE_PRECISION,eysmip,1,
      &              MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
-               CALL MPI_GATHER(asa,1,MPI_DOUBLE_PRECISION,asa_p,1,
+               CALL MPI_GATHER(asa,1,MPI_DOUBLE_PRECISION,asap,1,
      &              MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
                CALL MPI_GATHER(vdvol,1,MPI_DOUBLE_PRECISION,vdvolp,1,
@@ -345,10 +335,10 @@
 !     &                0,MPI_COMM_WORLD, IERR)                
 
-!     Write trajectory
+c     Write trajectory
                write (18,*) '@@@',iold,inode(rep_id+1)
                call outvbs(0,18)
                write (18,*) '###'
 !                call flush(18)
-!     Write current configuration
+c     Write current configuration
                if ((mod(iold, nsave).eq.0)) then
                   filebase = "conf_0000.var"
@@ -359,17 +349,19 @@
             if(rep_id.eq.0.and.myrank.eq.0) then
                randomCount = 0
-!  Update acceptance, temperature wise average of E and E^2 used to calculate
-!  specific heat. 
+c  Update acceptance, temperature wise average of E and E^2 used to calculate
+c  specific heat. 
                do i=1,num_rep
                   j=intem(i)
                   acy(i)=0.0
-!  Above: contents of acy1 are added to acy(i) a few lines down. 
-!  acy1(intem(i)) contains information received from the node at temperature
-!  i, on how many updates have been accepted in node intem(i). Since acz
-!  is not reset to 0 every cycle, acy(i) must be set to 0 here. Else, there 
-!  will be serious double counting and the values of acceptance printed 
-!  will be simply wrong.
+c  Above: contents of acy1 are added to acy(i) a few lines down. 
+c  acy1(intem(i)) contains information received from the node at temperature
+c  i, on how many updates have been accepted in node intem(i). Since acz
+c  is not reset to 0 every cycle, acy(i) must be set to 0 here. Else, there 
+c  will be serious double counting and the values of acceptance printed 
+c  will be simply wrong.
+                  e_minpt(i)=e_minp(intem(i))
                end do
                do i=1, num_rep
+                  e_minp(i) = e_minpt(i)
                   j=intem(i)
                   acy(i)=acy(i)+acy1(j)
@@ -379,16 +371,16 @@
 
 
-!     Write measurements to the time series file ts.d
+C     Write measurements to the time series file ts.d
                do i=1,num_rep
                   j=intem(i)
                      write(14,*) iold,i,j,pbe(i), dirp(j),
      &                 yol(j),eyslr(j), eyelp(j), eyvwp(j), eyhbp(j), 
-     &                    eyvrp(j),eysmip(j), asa_p(j), vdvolp(j),
+     &                    eyvrp(j),eysmip(j), asap(j), vdvolp(j),
      &                    rgyrp(j),nhelp(j),nbetp(j),mhbp(j),
-     &                 imhbp(j), nctotp(j),ncnatp(j), e_minp(j), 
+     &                 imhbp(j), nctotp(j),ncnatp(j), e_minp(i), 
      &                 eyabp(j),rmsdp(j)
 !                      call flush(14)
                end do
-!     Write the current parallel tempering information into par_R.in
+c     Write the current parallel tempering information into par_R.in
 !               timeLeft = llwrem(2) ! Time left till hard limit
 !               if ((mod(iold, nsave).eq.0).or.(timeLeft.lt.minTimeLeft)
@@ -401,6 +393,6 @@
      &                    h_maxp(i)
                   end do
-!     -------------------------- Various statistics of current run
-!               swp=nswp-nequi
+C     -------------------------- Various statistics of current run
+c               swp=nswp-nequi
                   swp=nsw
                   write(13,*) 'Acceptance rate for change of chains:'
@@ -408,7 +400,7 @@
                      temp=1.0d0/pbe(k1)/0.00198773
                      write(13,*) temp, acx1(k1)*2.0d0*nmes/swp 
-!  Above: it's the acceptance rate of exchange of replicas. Since a 
-!  replica exchange is attempted only once every nmes sweeps, the 
-!  rate should be normalized with (nmes/swp).
+c  Above: it's the acceptance rate of exchange of replicas. Since a 
+c  replica exchange is attempted only once every nmes sweeps, the 
+c  rate should be normalized with (nmes/swp).
                   end do 
                   write(13,*)
@@ -419,12 +411,12 @@
                      geavm(k1) = nmes*eavm(k1)/swp
                      gsph(k1)  = (nmes*sph(k1)/swp-geavm(k1)**2)
-     &                    *beta*beta/nresi
+     #                    *beta*beta/nresi
                      write(13,'(a,2f9.2,i4,f12.3)') 
      &                    'Temperature, Node,local acceptance rate:',
      &                    beta,temp,k,acy(k1)/dble(nsw*nvr)
-!  Above: Changed (nswp-nequi) in the denominator of acceptance as 
-!  acceptance values are initialized to 0 after equilibration cycles are
-!  finished. Note also that since this is being written in the middle of
-!  the simulation, it is normalized to nsw instead of nswp.
+c  Above: Changed (nswp-nequi) in the denominator of acceptance as 
+c  acceptance values are initialized to 0 after equilibration cycles are
+c  finished. Note also that since this is being written in the middle of
+c  the simulation, it is normalized to nsw instead of nswp.
                      write(13,'(a,3f12.2)') 
      &                    'Last Energy, Average Energy, Spec. Heat:', 
@@ -439,10 +431,10 @@
                end if
 
-!--------------------Parallel Tempering  update
-!     Swap with right neighbor (odd, even)            
+C--------------------Parallel Tempering  update
+c     Swap with right neighbor (odd, even)            
                if(odd.eq.1) then
                   nu=1
                   no1 = num_rep-1
-!     Swap with left neighbor (even, odd)
+c     Swap with left neighbor (even, odd)
                else
                   nu = 2
@@ -451,5 +443,5 @@
                do i=nu,no1,2
                   j=i+1
-!     Periodic bc for swaps
+c     Periodic bc for swaps
                   if(i.eq.num_rep) j=1
                   in=intem(i)
@@ -457,17 +449,17 @@
                   wij=exp(-pbe(i)*yol(jn)-pbe(j)*yol(in)
      &                 +pbe(i)*yol(in)+pbe(j)*yol(jn))
-! The random number generator is getting out of sync here, because
-!        the swap is only done on node 0!
+c The random number generator is getting out of sync here, because
+c        the swap is only done on node 0!
 ! Keep track of number of random numbers used.
                   rd=grnd()
                   randomCount = randomCount + 1
-!                  write (16,*) '>', iold, i,j
-!     &            ,pbe(i),yol(in), pbe(j), yol(jn), wij, rd
+c                  write (16,*) '>', iold, i,j
+c     &            ,pbe(i),yol(in), pbe(j), yol(jn), wij, rd
                   if(wij.ge.rd) then
-! Next line: Replica exchange only happens after equilibration, 
-! which takes place outside this loop over nsw. So, I think nsw.gt.nequi
-! is irrelevant for the calculation of acceptance of replica exchanges.
-! /Sandipan
-!                     if(nsw.gt.nequi) 
+c Next line: Replica exchange only happens after equilibration, 
+c which takes place outside this loop over nsw. So, I think nsw.gt.nequi
+c is irrelevant for the calculation of acceptance of replica exchanges.
+c /Sandipan
+c                     if(nsw.gt.nequi) 
                      acx1(i) = acx1(i)+1
                      intem(i) = jn
@@ -477,27 +469,31 @@
                   end if
                end do
-!     ---------------- End Loop over nodes which creates a new temperature
-!     map for all nodes, at the node with rank 0. 
-!     
+c     ---------------- End Loop over nodes which creates a new temperature
+c     map for all nodes, at the node with rank 0. 
+c     
                odd = 1 - odd
             end if
-!     End of "if (myrank.eq.0) ...". The block above includes PT update and 
-!     writing of observables into the time series file etc. 
+c     End of "if (myrank.eq.0) ...". The block above includes PT update and 
+c     writing of observables into the time series file etc. 
            
-!     Below: Communicate new temperature-node map to all nodes
+c     Below: Communicate new temperature-node map to all nodes
             CALL MPI_BCAST(INTEM,num_rep,MPI_INTEGER,0,MPI_COMM_WORLD,
      &           IERR)
             CALL MPI_BCAST(INODE,num_rep,MPI_INTEGER,0,MPI_COMM_WORLD,
      &           IERR)
-! Synchronize random number generators for replica 0
+         CALL MPI_BCAST(E_MINP,num_rep,MPI_DOUBLE_PRECISION,0,
+     &           MPI_COMM_WORLD,IERR)
+            CALL MPI_BCAST(H_MAXP,num_rep,MPI_INTEGER,0,MPI_COMM_WORLD,
+     &           IERR)
+c Synchronize random number generators for replica 0
             if (rep_id.eq.0) then
                CALL MPI_BCAST(randomCount,1,MPI_INTEGER,0,my_mpi_comm,
      &                IERR)
                if (myrank.ne.0) then
-!                  write (logString, *) '[', myrank,'] Missed', randomCount, 
+!                  write (*,*) '[', myrank,'] Missed', randomCount, 
 !     &                            'random numbers.'
                   do i = 1, randomCount
                      rd = grnd()
-!                     write (logString, *) '[', myrank,'] rd=', rd
+!                     write (*,*) '[', myrank,'] rd=', rd
                   enddo
                endif
@@ -505,14 +501,16 @@
 
             BETA=PBE(INODE(rep_id+1))
+            e_min = e_minp(inode(rep_id+1))
+            h_max = h_maxp(inode(rep_id+1))
             if (INODE(rep_id + 1).eq.1) dir = 1
             if (INODE(rep_id + 1).eq.num_rep) dir = -1
 
          endif
-!        End of "if (mod(iold,nmes).eq.0) ..."
+c        End of "if (mod(iold,nmes).eq.0) ..."
       end do
-!-----------End Loop over sweeps
-!     
-!     OUTPUT:
-!--------------------For Re-starts:
+c-----------End Loop over sweeps
+c     
+C     OUTPUT:
+C--------------------For Re-starts:
       nu = rep_id + 1
       filebase = "conf_0000.var"
@@ -520,5 +518,5 @@
       e_final=energy()
       if (partem_comm.ne.MPI_COMM_NULL) then
-         write (logString, *) rep_id, ' E_final', e_final
+         write (*,*) rep_id, ' E_final', e_final
       endif
       eol0 = eol
@@ -526,7 +524,7 @@
       if (partem_comm.ne.MPI_COMM_NULL) then
          CALL MPI_GATHER(EOL0,1,MPI_DOUBLE_PRECISION,YOL,1,
-     &        MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
+     #        MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
          CALL MPI_GATHER(acz0,1,MPI_DOUBLE_PRECISION,acy1,1,
-     &     MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
+     #     MPI_DOUBLE_PRECISION,0,partem_comm,IERR)
       endif
       
@@ -538,5 +536,5 @@
             write(13,*) i,inode(i),intem(i),yol(i),e_minp(i),h_maxp(i)
          end do
-!     -------------------------- Various statistics of current run
+C     -------------------------- Various statistics of current run
          swp=nswp
          write(13,*) 'Acceptance rate for change of chains:'
@@ -561,9 +559,9 @@
          end do
          close(13)
-!         close(16)
+c         close(16)
       end if
       close(18)
 
-!     =====================
+c     =====================
       CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
 
